<?php
/**
* - This module is a merge of Creditcard and Showparcels with several changes.
* - Merged by Ehinarr (ehinarr@msn.com)
* - Module Creditcard: By Kevin (http://Ox40.us/)
* - Showparcels: By Mend's (master_odlanier@hotmail.com)
* - THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
class CreditCard extends PaymentModule
{	
	private $_html = '';
	private $_postErrors = array();
	public  $bf, $path;
	public 	$requireCVC;

	public function __construct()
	{
		$this->name = 'creditcard';
		$this->displayName = 'creditcard';
		$this->tab = 'Payment';
		$this->version = 2.1;
  
        $this->currencies = true;
        $this->currencies_mode = 'checkbox';
		
   		$this->bf = new Blowfish(_COOKIE_KEY_, _COOKIE_IV_);			//Create Blowfish Object for Encryption
    
        $config = Configuration::getMultiple(array('CREDIT_CARD_REQUIRE_CVC','CREDIT_CARD_TOTAL', 'CREDIT_CARD_ID_ORDER_STATE', 'CREDIT_CARD_SHOWPARCELS'));
        if (isset($config['CREDIT_CARD_REQUIRE_CVC']))
        	$this->requireCVC = $config['CREDIT_CARD_REQUIRE_CVC'];
        if (isset($config['CREDIT_CARD_TOTAL']))
			$this->cardTotal = $config['CREDIT_CARD_TOTAL'];
        if (isset($config['CREDIT_CARD_ID_ORDER_STATE']))
			$this->idOrderState = $config['CREDIT_CARD_ID_ORDER_STATE'];
        if (isset($config['CREDIT_CARD_SHOWPARCELS']))
			$this->showparcels = $config['CREDIT_CARD_SHOWPARCELS'];
   
        parent::__construct();

		/* The parent construct is required for translations */
  		$this->displayName = $this->l('Credit Card');
		$this->description = $this->l('Accept offline payments by credit card');
        $this->path = $this->_path;
        
    }

	/**
	*	install()
	*	Called when 'Install' is clicked on module
	*/
	function install()
	{
		if (!parent::install()
                OR !$this->installDB()
                OR !$this->registerHook('payment')          	//Register Payment Hooks with Prestashop
			    OR !$this->registerHook('paymentReturn')
			    OR !$this->registerHook('adminOrder')
                OR !$this->_makeOrderState()
                OR !Configuration::updateValue('CREDIT_CARD_TOTAL', '0')			//Create Credit Card Order State
			    OR !Configuration::updateValue('CREDIT_CARD_REQUIRE_CVC', 'TRUE')
			)

            return true;
    }
    function uninstall()
	{
        $value	= Configuration::get('BAND_QTY');
		for ($i=0; $i <= ($value-1); $i++ )
		{
			!Configuration::deleteByName('BAND_NOME'  	 	 . $i );
			!Configuration::deleteByName('BAND_DESC'  	 	 . $i );
			!Configuration::deleteByName('BAND_JVALOR'	 	 . $i );
			!Configuration::deleteByName('BAND_JREC'	 	 . $i );
			!Configuration::deleteByName('BAND_PARCELAS'	 . $i );

         }
         
         if (!parent::uninstall()
		 OR !$this->uninstallDB()
         OR !Configuration::deleteByName('BAND_QTY')
         OR !Configuration::deleteByName('CREDIT_CARD_TOTAL')

		)
			return false;
		return true;
	}
 
    /**
	*	Create the table to store credit card data
	*/
    function installDB()
    {
        Db::getInstance()->Execute('
        CREATE TABLE `'._DB_PREFIX_.'order_credit_data` (
            `id_record` INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
	        `id_order` INT NOT NULL,
	        `data_string` TEXT NOT NULL,
	        `date_add` DATE,
	        `date_upd` DATE
         ) ENGINE = MYISAM;');
           return true;
	}
    /**
	*	Delete the table created to store credit card data
	*/
    function uninstallDB()
	{
		Db::getInstance()->Execute('DROP TABLE `'._DB_PREFIX_.'order_credit_data`;');
  		return true;
	}

    /**
	*	execPayment($cart)
	*	Called from payment.php
	*/
	function execPayment($cart)
    {
        if (!$this->active)
			return ;

		$errName    = '0';
		$errNumber  = '0';
		$errCVC     = '0';

		if(isset($_POST['paymentSubmit']))
		{
			$cardName       	= $_POST['cardName'];
        	$cardNumber     	= $_POST['cardNumber'];
        	$cardCVC     		= $_POST['cardCVC'];
        	$cardexpDate_mo     = $_POST['expDate_Month'];
        	$cardexpDate_yr     = $_POST['expDate_Year'];

            if (isset($_POST['cardParcels']))
				$cardParcels = $_POST['cardParcels'];


            if (!empty($cardParcels))
            	Configuration::updateValue('CREDIT_CARD_TOTAL',$cardParcels);

			

            if($cardName == "" || !Validate::isName($cardName))
				$errName = '1';
			if(!$this->validateCard($cardNumber))
				$errNumber = '1';
			if(strlen($cardCVC) < 2 || strlen($cardCVC) > 4)
				$errCVC = '1';

            if($errName == '1' || $errNumber == '1' || $errCVC == '1')
            {
                 global $cookie, $smarty;
                 $valor = number_format($cart->getOrderTotal(true, 3), 2, '.', '');
                 $moeda = new Currency($cookie->id_currency);
                 $smarty->assign(array(
                        'bandeiras'         => $this->showParcels($valor,$moeda),
                        'nbProducts' => $cart->nbProducts(),
			            'cust_currency' => $cookie->id_currency,
                        'currencies'        => $this->getCurrency(),
                        'currency_default'  => new Currency(Configuration::get('PS_CURRENCY_DEFAULT')),
                        'isoCode'           => Language::getIsoById(intval($cookie->id_lang)),
						'errName'			=> $errName,
						'errNumber'			=> $errNumber,
						'errCVC'			=> $errCVC,
                        'errParcel'         => $errParcel,
                        'cardName'			=> $cardName,
						'cardNumber'		=> $cardNumber,
						'cardCVC'			=> $cardCVC,
                        'total' 			=> number_format($cart->getOrderTotal(true, 3), 2, '.', ''),
						'requireCVC'		=> Configuration::get('CREDIT_CARD_REQUIRE_CVC'),
                        'this_path' 		=> $this->_path,
						'this_path_ssl' 	=> Configuration::get('PS_FO_PROTOCOL').$_SERVER['HTTP_HOST'].__PS_BASE_URI__."modules/{$this->name}/"));


			return $this->display(__FILE__, 'payment_execution.tpl');
            }
			else
			{
                    $cardName       = "{$cardName}<br/>";
                    $cardNumber     = "{$cardNumber}<br/>";
                    $cardCVC        = "{$cardCVC}<br/>";
                    $cardexpDate_yr = "{$cardexpDate_yr}<br/>";
                    
				/* Create Necessary variables for order placement */
					$cardString  = $this->l('Name:').'&nbsp;'.$cardName;
                   	$cardString .= $this->l('Card Number:').'&nbsp;'.$cardNumber;
					$cardString .= $this->requireCVC == "TRUE" ? $this->l('Card CVC:').'&nbsp;'.$cardCVC : "";
                 	$cardString .= $this->l('Card Exp:').'&nbsp;'.$cardexpDate_mo.'&nbsp;'.$cardexpDate_yr;
                    if($this->showparcels == '1')
                    {
                        $cardString .= $this->l('Parcels:').'&nbsp;'.$cardParcels;
                    }
					$cardString  = pSQL($this->bf->encrypt($cardString), true);

                    if ($this->showparcels == '1')
                    {
                        $split = Configuration::get('CREDIT_CARD_TOTAL');
                        if(strstr($split, 'x')==TRUE)
                        {
                            $split1    = explode('x', $split);
                            $split2    = explode('=', $split);
                            $nbParc    = trim($split1[0]);
                            $mont     = $split2[1];
                            $vlrParc   = number_format($split2[1] / $split1[0],2,",",".");

                        }
                        $currency = new Currency(intval(isset($_POST['currency_payement']) ? $_POST['currency_payement'] : $cookie->id_currency));

                        $this->validateOrderCreditcard($cart->id, $this->idOrderState, $mont, $this->displayName, $this->description, NULL, $currency->id);

                    }
                    else
                    {
                        $currency = new Currency(intval(isset($_POST['currency_payement']) ? $_POST['currency_payement'] : $cookie->id_currency));

                        $total = floatval(number_format($cart->getOrderTotal(true, 3), 2, '.', ''));
                        $this->validateOrder($cart->id, $this->idOrderState, $total, $this->displayName,     $this->description, NULL,      $currency->id);

                    }

				/* Insert Credit Card String into the database for the current order.*/
					$order = new Order($this->currentOrder);
					$this->addDataString($order->id,  nl2br($cardString));

				/* Once complete, redirect to order-confirmation.php */	
				Tools::redirectLink(__PS_BASE_URI__."order-confirmation.php?id_cart={$cart->id}&id_module={$this->id}&id_order={$this->currentOrder}&key={$order->secure_key}");
			}
     }
     else
     {
         global $cookie, $smarty;
         $products = $cart->getProducts();
         $this->_products = $products;
         $valor = number_format($cart->getOrderTotal(true, 3), 2, '.', '');
         $moeda = new Currency($cookie->id_currency);
         $smarty->assign(array(
                         'products'      => $this->_products,
                         'product_total' => number_format($cart->getOrderTotal(true, 4), 2, '.', ''),
                         'shipping_cost' => number_format($cart->getOrderTotal(true, 5), 2, '.', ''),
                         'bandeiras'     => $this->showParcels($valor,$moeda),
                         'nbProducts'    => $cart->nbProducts(),
		                 'cust_currency' => $cookie->id_currency,
                         'currencies'    => $this->getCurrency(),
                         'currency_default' => new Currency(Configuration::get('PS_CURRENCY_DEFAULT')),
                         'isoCode'          => Language::getIsoById(intval($cookie->id_lang)),
                         'total' 		 => number_format($cart->getOrderTotal(true, 3), 2, '.', ''),
                         'requireCVC'	 => Configuration::get('CREDIT_CARD_REQUIRE_CVC'),
                         'this_path' 	 => $this->_path,
                         'this_path_ssl' => Configuration::get('PS_FO_PROTOCOL').$_SERVER['HTTP_HOST'].__PS_BASE_URI__."modules/{$this->name}/"));

         return $this->display(__FILE__, 'payment_execution.tpl');

 }
}

	/**
	*	hookPayment($params)
	*	Called in Front Office at Payment Screen
	*/
	function hookPayment($params)
	{
        if (!$this->active)
			return ;
   
		global $smarty;
		
		$smarty->assign(array(
            'this_path' 		=> $this->_path,
            'this_path_ssl' 	=> Configuration::get('PS_FO_PROTOCOL').$_SERVER['HTTP_HOST'].__PS_BASE_URI__."modules/{$this->name}/"));
			
		return $this->display(__FILE__, 'payment.tpl');
	}
	
	/**
	*	hookadminOrder($params)
	*	Called in Back Office upon Order Review
	*	Note: Only return data if an order is a Credit Card order.
	*/
 
    function hookadminOrder($params)
	{
        if (!$this->active)
			return ;
   
		$id_order = $params['id_order'];

        if($this->isCreditCardOrder($id_order))
        {
             if (isset($_GET['remData']))
             {
                 if(intval($_GET['remData']) == 1)
                 $this->removeDataString($id_order);
                 }

			global $smarty;
			$data_string = $this->getDataString($id_order);
			$smarty->assign(array(
               	'ccDataString' 		=> $this->bf->decrypt($data_string),
				'id_order'			=> $id_order,
				'this_page'			=> $_SERVER['REQUEST_URI'],
				'this_path' 		=> $this->_path,
            	'this_path_ssl' 	=> Configuration::get('PS_FO_PROTOCOL').$_SERVER['HTTP_HOST'].__PS_BASE_URI__."modules/{$this->name}/"));
			return $this->display(__FILE__, 'invoice_block.tpl');
		}
		else
			return "";
	}
    /**
	*	hookPaymentReturn($params)
	*	Called in Front Office upon order placement
	*/
	public function hookPaymentReturn($params)
	{
        if (!$this->active)
			return ;

		global $cookie, $smarty;
        $state       = $params['objOrder']->getCurrentState();
        $products    = $params['objOrder']->getProducts();
        $id_order    = $params['objOrder']->id;
        $this->_products = $products;
        $data_string = $this->getDataString($id_order);
		if ($state == _PS_OS_OUTOFSTOCK_ or $state == $this->idOrderState)
			$smarty->assign(array(
                'products'      => $this->_products,
                'ccDataString' 	=> $this->bf->decrypt($data_string),
				'total_to_pay' 	=> Tools::displayPrice($params['total_to_pay'], $params['currencyObj'], false, false),
				'status' 		=> 'ok',
				'id_order' 		=> $params['objOrder']->id
			));
		else
			$smarty->assign('status', 'failed');

		return $this->display(__FILE__, 'payment_return.tpl');
	}

     public function displayErrors()
	 {

	   $nbErrors = sizeof($this->_postErrors);
	   $this->_html .= '
	   <div class="alert error">
			<h3>'.($nbErrors > 1 ? $this->l('There is') : $this->l('There are')).' '.$nbErrors.' '.($nbErrors > 1 ? $this->l('errors') : $this->l('error')).'</h3>
			<ol>';
		foreach ($this->_postErrors AS $error)
			$this->_html .= '<li>'.$error.'</li>';
		$this->_html .= '
			</ol>
		</div>';
	  }
      public function displayConf()
	  {
        $this->_html .= '
		<div class="conf confirm">
			<img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />
			'.$this->l('Settings updated').'
		</div>';
	}
    public function hookHeader()
	{

  		include('style/tab_showparcelamento.inc');

    }

	/**
	*	_displayCreditCard()
	*	Called in Back Office during Module Configuration
	*/
	private function _displayCreditCard()
	{
		$modDesc 	= $this->l('This module allows you to accept payments by credit card.');
		$modStatus	= $this->l('If the client chooses this payment type, the order status will change to \'Awaiting Credit Card Validation\'.');
		$modConfirm	= $this->l('Therefore, you will need to manually confirm the order as soon as you receive restitution.');
		$this->_html .= "<img src='../modules/creditcard/creditcard.jpg' style='float:left; margin-right:15px;' />
						<b>{$modDesc}</b><br /><br />
						{$modStatus}<br />
						{$modConfirm}<br /><br /><br />";
	}

	/**
	*	_displayForm()
	*	Called in Back Office during Module Configuration
	*/
	private function _displayForm()
	{
        $this->_html .= '
         <form action="'.$_SERVER['REQUEST_URI'].'" method="post">
           	<fieldset>
			<legend><img src="../img/admin/prefs.gif" />'.$this->l('Cards Configuration').'</legend>
			 <table border="0" width="900" cellpadding="0" cellspacing="2" id="form">
              <tr>
               <td style="vertical-align: top;"><b>'.$this->l('Require CVC Number:').'&nbsp;&nbsp;</b></td>
               <td style="vertical-align: top;"><input type="text" name="requireCVC" value="'.htmlentities(Tools::getValue('requireCVC', $this->requireCVC), ENT_COMPAT, 'UTF-8').'" style="width: 100px;" MAXLENGTH=5/>
               </td>
               <td>&nbsp;&nbsp;'.$this->l('Enter true or false into this text box.').'</p>
               </td>
               <td align="right"><input class="button" name="configSubmit" value= "'.$this->l('Update settings').'" type="submit" style="width: 200px;"/>
               </td>
              </tr>
              <tr>
               <td style="vertical-align: top;">
               <b><font color="red">'.$this->l('Show Parcels?:').'</font></b></td>
               <td align="left">
               <input type="checkbox" name="showparcels" value="1"  '.htmlentities(Configuration::get('CREDIT_CARD_SHOWPARCELS') == '1' ? 'checked="checked" ' : '').' >
               </td>
               <td>&nbsp;&nbsp;'.$this->l('Selected = Yes / Unselected = No.').'</p>
               </td>
               <td align="right">
               <input type="submit" name="showSubmit" value="'.$this->l('Show/No Show').'" class="button"  style="width: 200px;"/>
               </td>
              </tr>
             </table>
            </fieldset>
            </form> <br />
         <script>
			function addEvent() {
			  var ni 	= document.getElementById(\'myDiv\');
			  var numi 	= document.getElementById(\'theValue\');
			  var num 	= (document.getElementById("theValue").value -1)+ 2;
			  numi.value = num;
			  var divIdName = "my"+num+"Div";
			  var newdiv = document.createElement(\'div\');
			  newdiv.setAttribute("id",divIdName);
			  newdiv.innerHTML = "<hr><br />" + document.getElementById(\'teste\').innerHTML +
			  "<input type=\"button\" onclick=\"removeElement(\'"+divIdName+"\')\" class=\"button\" value=\"'.$this->l('Remover').'\"><br /><br />";
			  ni.appendChild(newdiv);
			}

			function removeElement(divNum) {
			  var d = document.getElementById(\'myDiv\');
			  var olddiv = document.getElementById(divNum);
			  d.removeChild(olddiv);
			}
			</script>

		<form action="'.$_SERVER['REQUEST_URI'].'" method="post" enctype="multipart/form-data" >
		<fieldset name="bandeirascard">
			<legend><img src="../img/admin/contact.gif" />'.$this->l('Parcels Configuration').'</legend>';

			$value	=	Configuration::get('BAND_QTY');

			if ( empty($value) ){
			$value	= 	1;
			}

			$i		=	1;
			while ( $i <= ($value) )
			{

			$this->_html .= '
              <div id="teste" align="left">
            	<div align="left">
					<label>'.$this->l('Card Name:').'</label>
					<div class="margin-form">
					<input type="text" size="33" id="nome" name="nome[]" value="'.
					Configuration::get('BAND_NOME'. ($i-1) ).'" />&nbsp;'.$this->l('VISA, MASTERCARD').'</div>
				</div>

				<div align="left">
					<label>'.$this->l('Description:').'</label>
					<div class="margin-form">
					<input type="text" size="39" name="desc[]" value="'.
					Configuration::get('BAND_DESC'. ($i-1) ).'" />
					'.$this->l('Field to customize. Enter you own information.').'</div>
				</div>

               	<div align="left">
					<label>'.$this->l('Interest tax:').'</label>
					<div class="margin-form">
					<input type="text" name="juros_valor[]"
					value="'.Configuration::get('BAND_JVALOR'. ($i-1) ).'" /> %
					&nbsp;&nbsp;
					<input type="checkbox" name="juros_rec[]"
					value="1" '.( Configuration::get('BAND_JREC'. ($i-1)) == 1 ? ' checked="checked" ' : ' ' ).' />
					'.$this->l('Interest compound').'</div>
				</div>

				<div align="left">
					<label>'.$this->l('Number of Parcels:').'</label>
					<div class="margin-form">
					<input type="text" size="3" name="parcelas[]" value="'.
					Configuration::get('BAND_PARCELAS'. ($i-1) ).'" /></div>
				</div>
		</div>
		<br />';

			$i++;
			}

			$this->_html .= '
			<input type="hidden" value="1" id="theValue" />
			<div id="myDiv"> </div>

			<div align="right">
				<input type="button" onclick="addEvent();"
				class="button" value="'.$this->l('Add').'">

				<input type="submit" name="submitBand" value="'.$this->l('Update settings').'"
				class="button" />
			</div>

		</fieldset>
		</form>';

     }
     
     /**
	*	getContent()
	*	Called in Back Office when user clicks "Configure"
	*/
 	function getContent()
    {
        $this->_html = '<h2>'.$this->displayName.'</h2>';		//Display Header

        if (isset($_POST['configSubmit']) OR isset($_POST['submitBand']) OR isset($_POST['showSubmit']))
        {
            $this->_postValidation();
            if (!sizeof($this->_postErrors))
            $this->_postProcess();
            else
            foreach ($this->_postErrors AS $err)
            $this->_html .= '<div class="alert error">'. $err .'</div>';
        }
        else
        $this->_html .= '<br />';
        $this->_displayCreditCard();
        $this->_displayForm();
        return $this->_html;
    }

    private function _postValidation()
    {
        if(isset($_POST['configSubmit']))
        {
            if (empty($_POST['requireCVC']))
            $this->_postErrors[] = $this->l('Please choose if TRUE or FALSE require cvc field.');
        }
    }

    private function _postProcess()
    {
        if(isset($_POST['configSubmit']))
        {
            Configuration::updateValue('CREDIT_CARD_REQUIRE_CVC', strtoupper($_POST['requireCVC']) == 'TRUE' ? "TRUE" : "FALSE");
        }
        if (isset($_POST['showSubmit']))
        {
            $showParcels = '0';
            if(isset($_POST['showparcels']))
            $showParcels = $_POST['showparcels'];
            Configuration::updateValue('CREDIT_CARD_SHOWPARCELS', $showParcels);
        }
        if (isset($_POST['submitBand']))
        {
            /** OBTM NOME DA BANDEIRA **/
            foreach($_POST['nome'] as $id => $value )
            {
                if ( $value == '' )
                {
                    unset($_POST['nome'][$id]);
                }
                Configuration::updateValue('BAND_NOME'.$id, $value);
            }
            /** OBTM A DESCRIO DA BANDEIRA **/
            foreach($_POST['desc'] as $id => $value )
            {
                if ( $value == '' )
                {
                    unset($_POST['desc'][$id]);
                }
                Configuration::updateValue('BAND_DESC'.$id, $value);
            }
            /** OBTM OS JUROS EM INTEIRO **/
            foreach($_POST['juros_valor'] as $id => $value )
            {
                if ( $value == '' )
                {
                    unset($_POST['juros_valor'][$id]);
                }
                Configuration::updateValue('BAND_JVALOR'.$id, $value);
                Configuration::updateValue('BAND_JREC'.$id, $_POST['juros_rec'][$id]);
            }
            /** OBTM A QUANTIDADE DE PARCELAS **/
            foreach($_POST['parcelas'] as $id => $value )
            {
                if ( $value == '' )
                {
                    unset($_POST['parcelas'][$id]);
                }
                Configuration::updateValue('BAND_PARCELAS'.$id, intval($value) );
            }
            Configuration::updateValue('BAND_QTY', sizeof($_POST['nome']));

        }

        $this->displayConf();
    }

    /**
	*	makeOrderState()
	*	An order state is necessary for this module to function.
	*	The id number of the order state is stored in a global configuration variable for use later
	*/
	private function _makeOrderState()
	{
		if(!(Configuration::get('CREDIT_CARD_ID_ORDER_STATE') > 0))
		{				
			$os              = new OrderState();
			$os->name        = array_fill(0,10,"Awaiting Credit Card Validation");	//Fill with english language translation
			$os->send_mail   = "1";
			$os->template    = array_fill(0,10,"creditcard");;
			$os->invoice     = "0";
			$os->color       = "#33FF99";
			$os->unremovable = false;
			$os->logable     = "0";
			$os->add();
			Configuration::updateValue('CREDIT_CARD_ID_ORDER_STATE',$os->id);
		}
	}
		
	/**
	*	isCreditCardOrder($id_order)
	*	Checks DB to see if an order used a creditcard
	*/
	public function isCreditCardOrder($id_order)
	{
		$db = Db::getInstance();
		$result = $db->getRow('
			SELECT * FROM `'._DB_PREFIX_.'order_credit_data`
			WHERE `id_order` = "'.$id_order.'"');

		return intval($result["id_order"]) != 0 ? true : false;
		
	}
	
	/**
	*	removeDataString($id_order)
	*	Removes credit card data from database upon order completion.
	*/
	public function removeDataString($id_order)
	{
		$removedString = pSQL($this->bf->encrypt("Credit Card Information Has Been Removed."), true);
		$db = Db::getInstance();
		$result = $db->Execute('
		UPDATE `'._DB_PREFIX_.'order_credit_data`
		SET `data_string` = "'.$removedString.'"
		WHERE `id_order` = "'.intval($id_order).'"');
	}
	
	/**
	*	addDataString($id_order, $data_string)
	*	Adds a data string to the database
	*/
	public function addDataString($id_order, $data_string)
	{
		$db = Db::getInstance();
		$result = $db->Execute('
		INSERT INTO `'._DB_PREFIX_.'order_credit_data`
		( `id_order`, `data_string` )
		VALUES
		("'.intval($id_order).'","'.$data_string.'")');
	}
	
	/**
	*	getDataString($id_order)
	*	Returns the associated credit card string from the database
	*/
	public function getDataString($id_order)
	{
		$db = Db::getInstance();
		$result = $db->ExecuteS('
		SELECT `data_string` FROM `'._DB_PREFIX_.'order_credit_data`
		WHERE `id_order` ="'.intval($id_order).'";');
		return $result[0]['data_string'];
	}
	
	/*
	 *	validateCard($cardnumber)
	 * 	Checks mod10 check digit of card, returns true if valid
	 */
	function validateCard($cardnumber)
	{
		$cardnumber = preg_replace("/\D|\s/", "", $cardnumber);  # strip any non-digits
		$cardlength = strlen($cardnumber);
		if ($cardlength != 0)
		{
			$parity = $cardlength % 2;
			$sum = 0;
			for ($i = 0; $i < $cardlength; $i++)
			{
				$digit = $cardnumber[$i];
				if ($i % 2 == $parity) $digit = $digit * 2;
					if ($digit > 9) $digit = $digit-9;
						$sum = $sum + $digit;
			}
			$valid = ($sum % 10 == 0);
			return $valid;
		}
		return false;
	}
    /**
	* Validate an order in database AND ADD EXTRA COST
	* Function called from a payment module
	*
	* @param integer $id_cart Value
	* @param integer $id_order_state Value
	* @param float $amountPaid Amount really paid by customer (in the default currency)
	* @param string $paymentMethod Payment method (eg. 'Credit cart')
	* @param string $message Message to attach to order
	*/

	function validateOrderCreditcard($id_cart, $id_order_state, $amountPaid, $paymentMethod = 'Unknown', $message = NULL, $extraVars = array(), $currency_special = NULL)
    {

        $cart = new Cart(intval($id_cart));

        /* Does order already exists ? */
		if (Validate::isLoadedObject($cart) AND $cart->OrderExists() == 0)
		{
			/* Copying data from cart */
			$order = new Order();
			$order->id_carrier          = intval($cart->id_carrier);
			$order->id_customer         = intval($cart->id_customer);
			$order->id_address_invoice  = intval($cart->id_address_invoice);
			$order->id_address_delivery = intval($cart->id_address_delivery);
			$vat_address                = new Address(intval($order->id_address_delivery));
			$id_zone                    = Address::getZoneById(intval($vat_address->id));
			$order->id_currency         = ($currency_special ? intval($currency_special) : intval($cart->id_currency));
			$order->id_lang             = intval($cart->id_lang);
			$order->id_cart             = intval($cart->id);
			$customer                   = new Customer(intval($order->id_customer));
			$order->secure_key          = pSQL($customer->secure_key);
			$order->payment             = substr($paymentMethod, 0, 32);
			if (isset($this->name))
				$order->module = $this->name;
			$order->total_paid_real     = number_format($amountPaid, 2, '.', '');
			$order->recyclable          = $cart->recyclable;
			$order->gift                = intval($cart->gift);
			$order->gift_message        = $cart->gift_message;
			$currency                   = new Currency($order->id_currency);
            /* Adding suchage to Amount paid */
			$mont = $amountPaid;
            $amountPaid                = floatval(Tools::convertPrice(floatval(number_format($mont, 2, '.', '')), $currency));
            //$amountPaid                 = $mont;
            $order->total_paid_real     = $amountPaid;
            /* Adding suchage to Total Products */
            $order->total_products     = floatval(Tools::convertPrice(floatval(number_format($cart->getOrderTotal(false, 1), 2, '.', '')), $currency));
            //$order1     = ($order1 * $x) + $order1;

            $order->total_discounts     = floatval(Tools::convertPrice(floatval(number_format(abs($cart->getOrderTotal(true, 2)), 2, '.', '')), $currency));
            /* Adding suchage to Total Shipping */
            $order->total_shipping     = floatval(Tools::convertPrice(floatval(number_format($cart->getOrderShippingCost(), 2, '.', '')), $currency));
             //$order3      = ($order3 * $x) + $order3;

            $order->total_wrapping      = floatval(Tools::convertPrice(floatval(number_format(abs($cart->getOrderTotal(true, 6)), 2, '.', '')), $currency));
            /* Adding suchage to Total paid */
            $order->total_paid          = floatval(Tools::convertPrice(floatval(number_format($mont, 2, '.', '')), $currency));
            //$order2          = $mont;

           /* Amount paid by customer is not the right one -> Status = payment error */
			if ($order->total_paid != $order->total_paid_real)
				$id_order_state = _PS_OS_ERROR_;

			/* Creating order */
			$result = $order->add();

			/* Next ! */
			if ($result AND isset($order->id))
			{
				/* Set order state in order history */
				$history = new OrderHistory();
				$history->id_order = intval($order->id);
				$history->changeIdOrderState(intval($id_order_state), intval($order->id));
				$history->addWithemail(true, $extraVars);

				/* Optional message to attach to this order */
				if (isset($message) AND !empty($message))
				{
					$msg = new Message();
					$message = strip_tags($message, '<br>');
					if (!Validate::isMessage($message))
						$message = $this->l('Payment message is not valid, please check your module!');
					$msg->message = $message;
					$msg->id_order = intval($order->id);
					$msg->private = 1;
					$msg->add();
				}

				/* Insert products from cart into order_detail table */
				$products = $cart->getProducts();
				$productsList = '';
				$db = Db::getInstance();
				$query = 'INSERT INTO `'._DB_PREFIX_.'order_detail`
					(`id_order`, `product_id`, `product_attribute_id`, `product_name`, `product_quantity`, `product_price`, `product_quantity_discount`, `product_ean13`, `product_reference`, `product_supplier_reference`, `product_weight`, `tax_name`, `tax_rate`, `ecotax`, `download_deadline`, `download_hash`)
				VALUES ';

				foreach ($products AS $key => $product)
				{
					if ($id_order_state != _PS_OS_CANCELED_ AND $id_order_state != _PS_OS_ERROR_)
					{
						if (($id_order_state != _PS_OS_OUTOFSTOCK_) AND (($updateResult = Product::updateQuantity($product)) === false OR $updateResult === -1))
							{
								$id_order_state = _PS_OS_OUTOFSTOCK_;
								$history = new OrderHistory();
								$history->id_order = intval($order->id);
								$history->changeIdOrderState(_PS_OS_OUTOFSTOCK_, intval($order->id));
								$history->addWithemail();
							}
						Hook::updateQuantity($product, $order);
					}
					$price = Tools::convertPrice(Product::getPriceStatic(intval($product['id_product']), false, ($product['id_product_attribute'] ? intval($product['id_product_attribute']) : NULL), 4), $currency);
					$price_wt = Tools::convertPrice(Product::getPriceStatic(intval($product['id_product']), true, ($product['id_product_attribute'] ? intval($product['id_product_attribute']) : NULL), 4), $currency);

					/* Add some informations for virtual products */
					$deadline = '0000-00-00 00:00:00';
					$download_hash = NULL;
					$productDownload = new ProductDownload();
					if ($id_product_download = $productDownload->getIdFromIdProduct(intval($product['id_product'])))
					{
						$productDownload = new ProductDownload(intval($id_product_download));
						$deadline = $productDownload->getDeadLine();
						$download_hash = $productDownload->getHash();
					}

					/* Exclude VAT */
					if (Tax::excludeTaxeOption())
					{
						$product['tax'] = 0;
						$product['rate'] = 0;
					}
					else
						$tax = Tax::getApplicableTax(intval($product['id_tax']), floatval($product['rate']));

					/* Quantity discount */
					Tools::dieObject($price, false);
					if ($product['quantity'] > 1 AND ($qtyD = QuantityDiscount::getDiscountFromQuantity($product['id_product'], $product['quantity'])))
					{
						$reduc = QuantityDiscount::getValue($price_wt, $qtyD->id_discount_type, $qtyD->value);
						$price -= $reduc / (1 + floatval($tax) / 100);
					}

					/* Query */
					$query .= '('.intval($order->id).',
						'.intval($product['id_product']).',
						'.(isset($product['id_product_attribute']) ? intval($product['id_product_attribute']) : 'NULL').',
						\''.pSQL($product['name'].((isset($product['attributes']) AND $product['attributes'] != NULL) ? ' - '.$product['attributes'] : '')).'\',
						'.intval($product['quantity']).',
						'.floatval($price).',
						'.floatval($reduc).',
						'.(empty($product['ean13']) ? 'NULL' : '\''.pSQL($product['ean13']).'\'').',
						'.(empty($product['reference']) ? 'NULL' : '\''.pSQL($product['reference']).'\'').',
						'.(empty($product['supplier_reference']) ? 'NULL' : '\''.pSQL($product['supplier_reference']).'\'').',
						'.floatval($product['weight']).',
						\''.(!$tax ? '' : pSQL($product['tax'])).'\',
						'.floatval($tax).',
						'.floatval($product['ecotax']).',
						\''.pSQL($deadline).'\',
						\''.pSQL($download_hash).'\'),';

					$productsList .=
						'<tr style="background-color:'.($key%2 ? '#DDE2E6' : '#EBECEE').';">
							<td style="padding:0.6em 0.4em;">'.$product['reference'].'</td>
							<td style="padding:0.6em 0.4em;"><strong>'.$product['name'].(isset($product['attributes_small']) ? ' '.$product['attributes_small'] : '').'</strong></td>
							<td style="padding:0.6em 0.4em; text-align:right;">'.Tools::displayPrice($price * ($tax + 100) / 100, $currency, false, false).'</td>
							<td style="padding:0.6em 0.4em; text-align:center;">'.intval($product['quantity']).'</td>
							<td style="padding:0.6em 0.4em; text-align:right;">'.Tools::displayPrice(intval($product['quantity']) * ($price * ($tax + 100) / 100), $currency, false, false).'</td>
						</tr>';
				} /* end foreach ($products) */
				$query = rtrim($query, ',');
				$result = $db->Execute($query);

				/* Insert discounts from cart into order_discount table */
				$discounts = $cart->getDiscounts();
				$discountsList = '';
				foreach ($discounts AS $discount)
				{
					$objDiscount = new Discount(intval($discount['id_discount']));
					$value = number_format($objDiscount->getValue(sizeof($discounts), $cart->getOrderTotal(true, 1), $order->total_shipping), 2);
					$order->addDiscount($objDiscount->id, $objDiscount->name, $value);
					if ($id_order_state != _PS_OS_ERROR_ AND $id_order_state != _PS_OS_CANCELED_)
						$objDiscount->quantity = $objDiscount->quantity - 1;
					$objDiscount->update();

					$discountsList .=
					'<tr style="background-color:#EBECEE;">
							<td colspan="4" style="padding:0.6em 0.4em; text-align:right;">'.$this->l('Voucher code:').' '.$objDiscount->name.'</td>
							<td style="padding:0.6em 0.4em; text-align:right;">-'.Tools::displayPrice($value, $currency, false, false).'</td>
					</tr>';
				}

				/* Specify order id for message */
				$oldMessage = Message::getMessageByCartId(intval($cart->id));
				if ($oldMessage)
				{
					$message = new Message(intval($oldMessage['id_message']));
					$message->id_order = intval($order->id);
					$message->update();
				}

				/* Hook new order */
				$orderStatus = new OrderState(intval($id_order_state));
				if (Validate::isLoadedObject($orderStatus))
					Hook::newOrder($cart, $order, $customer, $currency, $orderStatus);

				/* Send an e-mail to customer */
				if ($id_order_state != _PS_OS_ERROR_ AND $id_order_state != _PS_OS_CANCELED_ AND $customer->id)
				{
					$invoice = new Address(intval($order->id_address_invoice));
					$delivery = new Address(intval($order->id_address_delivery));
					$carrier = new Carrier(intval($order->id_carrier));
					$delivery_state = $delivery->id_state ? new State(intval($delivery->id_state)) : false;
					$invoice_state = $invoice->id_state ? new State(intval($invoice->id_state)) : false;

					$data = array(
						'{firstname}' => $customer->firstname,
						'{lastname}' => $customer->lastname,
						'{email}' => $customer->email,
						'{delivery_firstname}'   => $delivery->firstname,
						'{delivery_lastname}'    => $delivery->lastname,
						'{delivery_address1}'    => $delivery->address1,
						'{delivery_address2}'    => $delivery->address2,
						'{delivery_city}'        => $delivery->city,
						'{delivery_postal_code}' => $delivery->postcode,
						'{delivery_country}' => $delivery->country,
						'{delivery_state}' => $delivery->id_state ? $delivery_state->name : '',
						'{delivery_phone}' => $delivery->phone,
						'{invoice_firstname}' => $invoice->firstname,
						'{invoice_lastname}' => $invoice->lastname,
						'{invoice_address2}' => $invoice->address2,
						'{invoice_address1}' => $invoice->address1,
						'{invoice_city}' => $invoice->city,
						'{invoice_postal_code}' => $invoice->postcode,
						'{invoice_country}' => $invoice->country,
						'{invoice_state}' => $invoice->id_state ? $invoice_state->name : '',
						'{invoice_phone}' => $invoice->phone,
						'{order_name}' => sprintf("%06d", intval($order->id)),
						'{date}' => Tools::displayDate(date('Y-m-d h:i:s'), intval($order->id_lang), 1),
						'{carrier}' => (strval($carrier->name) != '0' ? $carrier->name : Configuration::get('PS_SHOP_NAME')),
						'{payment}' => $order->payment,
						'{products}' => $productsList,
						'{discounts}' => $discountsList,
						'{total_paid}'      => Tools::displayPrice($order->total_paid,     $currency, false, false),
						'{total_products}'  => Tools::displayPrice($order->total_paid -    $order->total_shipping - $order->total_wrapping+ $order->total_discounts, $currency, false, false),
						'{total_discounts}' => Tools::displayPrice($order->total_discounts,$currency, false, false),
						'{total_shipping}'  => Tools::displayPrice($order->total_shipping, $currency, false, false),
						'{total_wrapping}'  => Tools::displayPrice($order->total_wrapping, $currency, false, false)
					);

					if (is_array($extraVars))
						$data = array_merge($data, $extraVars);

					/* Join PDF invoice */
					if (Validate::isLoadedObject($orderStatus) AND $orderStatus->invoice)
					{
						$fileAttachment['content'] = PDF::invoice($order, 'S');
						$fileAttachment['name'] = sprintf('FA%06d.pdf', intval($order->id));
						$fileAttachment['mime'] = 'application/pdf';
					}
					else
						$fileAttachment = NULL;

					if ($orderStatus->send_email AND Validate::isEmail($customer->email))
						Mail::Send(intval($order->id_lang), 'order_conf', 'Order confirmation', $data, $customer->email, $customer->firstname.' '.$customer->lastname, NULL, NULL, $fileAttachment);

					$this->currentOrder = intval($order->id);
					return true;
				}
			}
			else
				die(Tools::displayError('Order creation failed'));
		}
		else
			die(Tools::displayError('An order has already been placed using this cart'));
	}

    function showParcels($valor,$moeda)
    {
        if ($this->showparcels == '0')
        $bandeiras = '';
        else
        {
            $this->hookHeader();
            
            /** QUANTIDADE DE BANDEIRAS **/
            $value	= Configuration::get('BAND_QTY');
            
            /** LOOPING NAS BANDEIRAS **/
            for ($i_band=0; $i_band <= ($value-1); $i_band++ )
            {
                $bandeiras[$i_band]['nome'] 	= Configuration::get('BAND_NOME'  	 	 . $i_band );
                $bandeiras[$i_band]['desc'] 	= Configuration::get('BAND_DESC'  	 	 . $i_band );
                $bandeiras[$i_band]['jval'] 	= Configuration::get('BAND_JVALOR'	 	 . $i_band );
                $bandeiras[$i_band]['jrec'] 	= Configuration::get('BAND_JREC'	 	 . $i_band );
                $bandeiras[$i_band]['npar'] 	= Configuration::get('BAND_PARCELAS'	 . $i_band );
            }
            foreach ( $bandeiras as $id => $value )
            {
                /** CAPTURO A METADE DAS PARCELAS **/
                $bandeiras[$id]['dividir']	= round($bandeiras[$id]['npar'] / 2);
                /** LOOPING ENTRE PARCELAS E BANDEIRAS **/
                for ($i_par=1; $i_par <= $bandeiras[$id]['npar']; $i_par++ )
                {
                    $juros		= $bandeiras[$id]['jval'] / 100;
                    
					
                    if ($bandeiras[$id]['jval'] == 0 )
                    {
                        $mont = number_format($valor, 2, '.', '');
                    }
                    /** JUROS COMPOSTOS **/
                    elseif ( $bandeiras[$id]['jrec'] == '1' )
                    {
                        $mont = number_format($valor * pow( (1 + $juros), ($i_par) ), 2, '.', '');
                    }
                    /** JUROS SIMPLES **/
                    else
                    {
                        $mont = number_format($valor + ($i_par * ($juros * $valor)), 2, '.', '');
                    }
					/** CHECA SE  A PRIMEIRA PARCELA E DEIXA-A LIVRE DE JUROS **/
					if ( $i_par == 1 )
                    {
                        $mont = number_format(($valor * $i_par), 2, '.', '');
                    }
                    $parcela	= floatval($mont) / $i_par;
                    $price		= Tools::displayPrice(floatval($parcela),$moeda, false, true);
                    $bandeiras[$id]['parcelas'][$i_par] = array( $i_par, $price, $mont, $juros);
                }
            }
        }
        return $bandeiras;
    }

}

?>
